#include "colors.hpp"

namespace doppia {

namespace rgb8_colors
{
const boost::gil::rgb8c_pixel_t
white(255, 255, 255), black(0,0,0),
pink(255, 192, 203), dark_pink(127, 96, 101),
red(255, 0, 0), dark_red(127, 0, 0),
orange(255, 127, 0), dark_orange(127, 63, 0),
brown(150, 75, 0), dark_brown(75, 38, 0),
yellow(255, 205, 0), dark_yellow(127, 102, 0),
gray(128, 128, 128),
green(0, 255, 0), dark_green(0, 127, 0),
cyan(0, 255, 255), dark_cyan(0, 127, 127),
blue(0, 0, 255), dark_blue(0, 0, 125),
violet(127, 0, 255), dark_violet(64, 0, 127),
magenta(255, 0, 255), dark_magenta(139, 0, 139);


// 640 colors --> 640x3 matrix
const boost::uint8_t
//const boost::gil::rgb8c_pixel_t jet_color_map[] // only valid in C++11
jet_color_map[][3] = {
    {   0,     0,   129 },
    {   0,     0,   131 },
    {   0,     0,   132 },
    {   0,     0,   134 },
    {   0,     0,   135 },
    {   0,     0,   137 },
    {   0,     0,   139 },
    {   0,     0,   140 },
    {   0,     0,   142 },
    {   0,     0,   143 },
    {   0,     0,   145 },
    {   0,     0,   147 },
    {   0,     0,   148 },
    {   0,     0,   150 },
    {   0,     0,   151 },
    {   0,     0,   153 },
    {   0,     0,   155 },
    {   0,     0,   156 },
    {   0,     0,   158 },
    {   0,     0,   159 },
    {   0,     0,   161 },
    {   0,     0,   163 },
    {   0,     0,   164 },
    {   0,     0,   166 },
    {   0,     0,   167 },
    {   0,     0,   169 },
    {   0,     0,   171 },
    {   0,     0,   172 },
    {   0,     0,   174 },
    {   0,     0,   175 },
    {   0,     0,   177 },
    {   0,     0,   179 },
    {   0,     0,   180 },
    {   0,     0,   182 },
    {   0,     0,   183 },
    {   0,     0,   185 },
    {   0,     0,   186 },
    {   0,     0,   188 },
    {   0,     0,   190 },
    {   0,     0,   191 },
    {   0,     0,   193 },
    {   0,     0,   194 },
    {   0,     0,   196 },
    {   0,     0,   198 },
    {   0,     0,   199 },
    {   0,     0,   201 },
    {   0,     0,   202 },
    {   0,     0,   204 },
    {   0,     0,   206 },
    {   0,     0,   207 },
    {   0,     0,   209 },
    {   0,     0,   210 },
    {   0,     0,   212 },
    {   0,     0,   214 },
    {   0,     0,   215 },
    {   0,     0,   217 },
    {   0,     0,   218 },
    {   0,     0,   220 },
    {   0,     0,   222 },
    {   0,     0,   223 },
    {   0,     0,   225 },
    {   0,     0,   226 },
    {   0,     0,   228 },
    {   0,     0,   230 },
    {   0,     0,   231 },
    {   0,     0,   233 },
    {   0,     0,   234 },
    {   0,     0,   236 },
    {   0,     0,   237 },
    {   0,     0,   239 },
    {   0,     0,   241 },
    {   0,     0,   242 },
    {   0,     0,   244 },
    {   0,     0,   245 },
    {   0,     0,   247 },
    {   0,     0,   249 },
    {   0,     0,   250 },
    {   0,     0,   252 },
    {   0,     0,   253 },
    {   0,     0,   255 },
    {   0,     2,   255 },
    {   0,     3,   255 },
    {   0,     5,   255 },
    {   0,     6,   255 },
    {   0,     8,   255 },
    {   0,    10,   255 },
    {   0,    11,   255 },
    {   0,    13,   255 },
    {   0,    14,   255 },
    {   0,    16,   255 },
    {   0,    18,   255 },
    {   0,    19,   255 },
    {   0,    21,   255 },
    {   0,    22,   255 },
    {   0,    24,   255 },
    {   0,    26,   255 },
    {   0,    27,   255 },
    {   0,    29,   255 },
    {   0,    30,   255 },
    {   0,    32,   255 },
    {   0,    33,   255 },
    {   0,    35,   255 },
    {   0,    37,   255 },
    {   0,    38,   255 },
    {   0,    40,   255 },
    {   0,    41,   255 },
    {   0,    43,   255 },
    {   0,    45,   255 },
    {   0,    46,   255 },
    {   0,    48,   255 },
    {   0,    49,   255 },
    {   0,    51,   255 },
    {   0,    53,   255 },
    {   0,    54,   255 },
    {   0,    56,   255 },
    {   0,    57,   255 },
    {   0,    59,   255 },
    {   0,    61,   255 },
    {   0,    62,   255 },
    {   0,    64,   255 },
    {   0,    65,   255 },
    {   0,    67,   255 },
    {   0,    69,   255 },
    {   0,    70,   255 },
    {   0,    72,   255 },
    {   0,    73,   255 },
    {   0,    75,   255 },
    {   0,    77,   255 },
    {   0,    78,   255 },
    {   0,    80,   255 },
    {   0,    81,   255 },
    {   0,    83,   255 },
    {   0,    84,   255 },
    {   0,    86,   255 },
    {   0,    88,   255 },
    {   0,    89,   255 },
    {   0,    91,   255 },
    {   0,    92,   255 },
    {   0,    94,   255 },
    {   0,    96,   255 },
    {   0,    97,   255 },
    {   0,    99,   255 },
    {   0,   100,   255 },
    {   0,   102,   255 },
    {   0,   104,   255 },
    {   0,   105,   255 },
    {   0,   107,   255 },
    {   0,   108,   255 },
    {   0,   110,   255 },
    {   0,   112,   255 },
    {   0,   113,   255 },
    {   0,   115,   255 },
    {   0,   116,   255 },
    {   0,   118,   255 },
    {   0,   120,   255 },
    {   0,   121,   255 },
    {   0,   123,   255 },
    {   0,   124,   255 },
    {   0,   126,   255 },
    {   0,   128,   255 },
    {   0,   129,   255 },
    {   0,   131,   255 },
    {   0,   132,   255 },
    {   0,   134,   255 },
    {   0,   135,   255 },
    {   0,   137,   255 },
    {   0,   139,   255 },
    {   0,   140,   255 },
    {   0,   142,   255 },
    {   0,   143,   255 },
    {   0,   145,   255 },
    {   0,   147,   255 },
    {   0,   148,   255 },
    {   0,   150,   255 },
    {   0,   151,   255 },
    {   0,   153,   255 },
    {   0,   155,   255 },
    {   0,   156,   255 },
    {   0,   158,   255 },
    {   0,   159,   255 },
    {   0,   161,   255 },
    {   0,   163,   255 },
    {   0,   164,   255 },
    {   0,   166,   255 },
    {   0,   167,   255 },
    {   0,   169,   255 },
    {   0,   171,   255 },
    {   0,   172,   255 },
    {   0,   174,   255 },
    {   0,   175,   255 },
    {   0,   177,   255 },
    {   0,   179,   255 },
    {   0,   180,   255 },
    {   0,   182,   255 },
    {   0,   183,   255 },
    {   0,   185,   255 },
    {   0,   186,   255 },
    {   0,   188,   255 },
    {   0,   190,   255 },
    {   0,   191,   255 },
    {   0,   193,   255 },
    {   0,   194,   255 },
    {   0,   196,   255 },
    {   0,   198,   255 },
    {   0,   199,   255 },
    {   0,   201,   255 },
    {   0,   202,   255 },
    {   0,   204,   255 },
    {   0,   206,   255 },
    {   0,   207,   255 },
    {   0,   209,   255 },
    {   0,   210,   255 },
    {   0,   212,   255 },
    {   0,   214,   255 },
    {   0,   215,   255 },
    {   0,   217,   255 },
    {   0,   218,   255 },
    {   0,   220,   255 },
    {   0,   222,   255 },
    {   0,   223,   255 },
    {   0,   225,   255 },
    {   0,   226,   255 },
    {   0,   228,   255 },
    {   0,   230,   255 },
    {   0,   231,   255 },
    {   0,   233,   255 },
    {   0,   234,   255 },
    {   0,   236,   255 },
    {   0,   237,   255 },
    {   0,   239,   255 },
    {   0,   241,   255 },
    {   0,   242,   255 },
    {   0,   244,   255 },
    {   0,   245,   255 },
    {   0,   247,   255 },
    {   0,   249,   255 },
    {   0,   250,   255 },
    {   0,   252,   255 },
    {   0,   253,   255 },
    {   0,   255,   255 },
    {   2,   255,   253 },
    {   3,   255,   252 },
    {   5,   255,   250 },
    {   6,   255,   249 },
    {   8,   255,   247 },
    {  10,   255,   245 },
    {  11,   255,   244 },
    {  13,   255,   242 },
    {  14,   255,   241 },
    {  16,   255,   239 },
    {  18,   255,   237 },
    {  19,   255,   236 },
    {  21,   255,   234 },
    {  22,   255,   233 },
    {  24,   255,   231 },
    {  26,   255,   230 },
    {  27,   255,   228 },
    {  29,   255,   226 },
    {  30,   255,   225 },
    {  32,   255,   223 },
    {  33,   255,   222 },
    {  35,   255,   220 },
    {  37,   255,   218 },
    {  38,   255,   217 },
    {  40,   255,   215 },
    {  41,   255,   214 },
    {  43,   255,   212 },
    {  45,   255,   210 },
    {  46,   255,   209 },
    {  48,   255,   207 },
    {  49,   255,   206 },
    {  51,   255,   204 },
    {  53,   255,   202 },
    {  54,   255,   201 },
    {  56,   255,   199 },
    {  57,   255,   198 },
    {  59,   255,   196 },
    {  61,   255,   194 },
    {  62,   255,   193 },
    {  64,   255,   191 },
    {  65,   255,   190 },
    {  67,   255,   188 },
    {  69,   255,   186 },
    {  70,   255,   185 },
    {  72,   255,   183 },
    {  73,   255,   182 },
    {  75,   255,   180 },
    {  77,   255,   179 },
    {  78,   255,   177 },
    {  80,   255,   175 },
    {  81,   255,   174 },
    {  83,   255,   172 },
    {  84,   255,   171 },
    {  86,   255,   169 },
    {  88,   255,   167 },
    {  89,   255,   166 },
    {  91,   255,   164 },
    {  92,   255,   163 },
    {  94,   255,   161 },
    {  96,   255,   159 },
    {  97,   255,   158 },
    {  99,   255,   156 },
    { 100,   255,   155 },
    { 102,   255,   153 },
    { 104,   255,   151 },
    { 105,   255,   150 },
    { 107,   255,   148 },
    { 108,   255,   147 },
    { 110,   255,   145 },
    { 112,   255,   143 },
    { 113,   255,   142 },
    { 115,   255,   140 },
    { 116,   255,   139 },
    { 118,   255,   137 },
    { 120,   255,   135 },
    { 121,   255,   134 },
    { 123,   255,   132 },
    { 124,   255,   131 },
    { 126,   255,   129 },
    { 128,   255,   128 },
    { 129,   255,   126 },
    { 131,   255,   124 },
    { 132,   255,   123 },
    { 134,   255,   121 },
    { 135,   255,   120 },
    { 137,   255,   118 },
    { 139,   255,   116 },
    { 140,   255,   115 },
    { 142,   255,   113 },
    { 143,   255,   112 },
    { 145,   255,   110 },
    { 147,   255,   108 },
    { 148,   255,   107 },
    { 150,   255,   105 },
    { 151,   255,   104 },
    { 153,   255,   102 },
    { 155,   255,   100 },
    { 156,   255,    99 },
    { 158,   255,    97 },
    { 159,   255,    96 },
    { 161,   255,    94 },
    { 163,   255,    92 },
    { 164,   255,    91 },
    { 166,   255,    89 },
    { 167,   255,    88 },
    { 169,   255,    86 },
    { 171,   255,    84 },
    { 172,   255,    83 },
    { 174,   255,    81 },
    { 175,   255,    80 },
    { 177,   255,    78 },
    { 179,   255,    77 },
    { 180,   255,    75 },
    { 182,   255,    73 },
    { 183,   255,    72 },
    { 185,   255,    70 },
    { 186,   255,    69 },
    { 188,   255,    67 },
    { 190,   255,    65 },
    { 191,   255,    64 },
    { 193,   255,    62 },
    { 194,   255,    61 },
    { 196,   255,    59 },
    { 198,   255,    57 },
    { 199,   255,    56 },
    { 201,   255,    54 },
    { 202,   255,    53 },
    { 204,   255,    51 },
    { 206,   255,    49 },
    { 207,   255,    48 },
    { 209,   255,    46 },
    { 210,   255,    45 },
    { 212,   255,    43 },
    { 214,   255,    41 },
    { 215,   255,    40 },
    { 217,   255,    38 },
    { 218,   255,    37 },
    { 220,   255,    35 },
    { 222,   255,    33 },
    { 223,   255,    32 },
    { 225,   255,    30 },
    { 226,   255,    29 },
    { 228,   255,    27 },
    { 230,   255,    26 },
    { 231,   255,    24 },
    { 233,   255,    22 },
    { 234,   255,    21 },
    { 236,   255,    19 },
    { 237,   255,    18 },
    { 239,   255,    16 },
    { 241,   255,    14 },
    { 242,   255,    13 },
    { 244,   255,    11 },
    { 245,   255,    10 },
    { 247,   255,     8 },
    { 249,   255,     6 },
    { 250,   255,     5 },
    { 252,   255,     3 },
    { 253,   255,     2 },
    { 255,   255,     0 },
    { 255,   253,     0 },
    { 255,   252,     0 },
    { 255,   250,     0 },
    { 255,   249,     0 },
    { 255,   247,     0 },
    { 255,   245,     0 },
    { 255,   244,     0 },
    { 255,   242,     0 },
    { 255,   241,     0 },
    { 255,   239,     0 },
    { 255,   237,     0 },
    { 255,   236,     0 },
    { 255,   234,     0 },
    { 255,   233,     0 },
    { 255,   231,     0 },
    { 255,   230,     0 },
    { 255,   228,     0 },
    { 255,   226,     0 },
    { 255,   225,     0 },
    { 255,   223,     0 },
    { 255,   222,     0 },
    { 255,   220,     0 },
    { 255,   218,     0 },
    { 255,   217,     0 },
    { 255,   215,     0 },
    { 255,   214,     0 },
    { 255,   212,     0 },
    { 255,   210,     0 },
    { 255,   209,     0 },
    { 255,   207,     0 },
    { 255,   206,     0 },
    { 255,   204,     0 },
    { 255,   202,     0 },
    { 255,   201,     0 },
    { 255,   199,     0 },
    { 255,   198,     0 },
    { 255,   196,     0 },
    { 255,   194,     0 },
    { 255,   193,     0 },
    { 255,   191,     0 },
    { 255,   190,     0 },
    { 255,   188,     0 },
    { 255,   186,     0 },
    { 255,   185,     0 },
    { 255,   183,     0 },
    { 255,   182,     0 },
    { 255,   180,     0 },
    { 255,   179,     0 },
    { 255,   177,     0 },
    { 255,   175,     0 },
    { 255,   174,     0 },
    { 255,   172,     0 },
    { 255,   171,     0 },
    { 255,   169,     0 },
    { 255,   167,     0 },
    { 255,   166,     0 },
    { 255,   164,     0 },
    { 255,   163,     0 },
    { 255,   161,     0 },
    { 255,   159,     0 },
    { 255,   158,     0 },
    { 255,   156,     0 },
    { 255,   155,     0 },
    { 255,   153,     0 },
    { 255,   151,     0 },
    { 255,   150,     0 },
    { 255,   148,     0 },
    { 255,   147,     0 },
    { 255,   145,     0 },
    { 255,   143,     0 },
    { 255,   142,     0 },
    { 255,   140,     0 },
    { 255,   139,     0 },
    { 255,   137,     0 },
    { 255,   135,     0 },
    { 255,   134,     0 },
    { 255,   132,     0 },
    { 255,   131,     0 },
    { 255,   129,     0 },
    { 255,   128,     0 },
    { 255,   126,     0 },
    { 255,   124,     0 },
    { 255,   123,     0 },
    { 255,   121,     0 },
    { 255,   120,     0 },
    { 255,   118,     0 },
    { 255,   116,     0 },
    { 255,   115,     0 },
    { 255,   113,     0 },
    { 255,   112,     0 },
    { 255,   110,     0 },
    { 255,   108,     0 },
    { 255,   107,     0 },
    { 255,   105,     0 },
    { 255,   104,     0 },
    { 255,   102,     0 },
    { 255,   100,     0 },
    { 255,    99,     0 },
    { 255,    97,     0 },
    { 255,    96,     0 },
    { 255,    94,     0 },
    { 255,    92,     0 },
    { 255,    91,     0 },
    { 255,    89,     0 },
    { 255,    88,     0 },
    { 255,    86,     0 },
    { 255,    84,     0 },
    { 255,    83,     0 },
    { 255,    81,     0 },
    { 255,    80,     0 },
    { 255,    78,     0 },
    { 255,    77,     0 },
    { 255,    75,     0 },
    { 255,    73,     0 },
    { 255,    72,     0 },
    { 255,    70,     0 },
    { 255,    69,     0 },
    { 255,    67,     0 },
    { 255,    65,     0 },
    { 255,    64,     0 },
    { 255,    62,     0 },
    { 255,    61,     0 },
    { 255,    59,     0 },
    { 255,    57,     0 },
    { 255,    56,     0 },
    { 255,    54,     0 },
    { 255,    53,     0 },
    { 255,    51,     0 },
    { 255,    49,     0 },
    { 255,    48,     0 },
    { 255,    46,     0 },
    { 255,    45,     0 },
    { 255,    43,     0 },
    { 255,    41,     0 },
    { 255,    40,     0 },
    { 255,    38,     0 },
    { 255,    37,     0 },
    { 255,    35,     0 },
    { 255,    33,     0 },
    { 255,    32,     0 },
    { 255,    30,     0 },
    { 255,    29,     0 },
    { 255,    27,     0 },
    { 255,    26,     0 },
    { 255,    24,     0 },
    { 255,    22,     0 },
    { 255,    21,     0 },
    { 255,    19,     0 },
    { 255,    18,     0 },
    { 255,    16,     0 },
    { 255,    14,     0 },
    { 255,    13,     0 },
    { 255,    11,     0 },
    { 255,    10,     0 },
    { 255,     8,     0 },
    { 255,     6,     0 },
    { 255,     5,     0 },
    { 255,     3,     0 },
    { 255,     2,     0 },
    { 255,     0,     0 },
    { 253,     0,     0 },
    { 252,     0,     0 },
    { 250,     0,     0 },
    { 249,     0,     0 },
    { 247,     0,     0 },
    { 245,     0,     0 },
    { 244,     0,     0 },
    { 242,     0,     0 },
    { 241,     0,     0 },
    { 239,     0,     0 },
    { 237,     0,     0 },
    { 236,     0,     0 },
    { 234,     0,     0 },
    { 233,     0,     0 },
    { 231,     0,     0 },
    { 230,     0,     0 },
    { 228,     0,     0 },
    { 226,     0,     0 },
    { 225,     0,     0 },
    { 223,     0,     0 },
    { 222,     0,     0 },
    { 220,     0,     0 },
    { 218,     0,     0 },
    { 217,     0,     0 },
    { 215,     0,     0 },
    { 214,     0,     0 },
    { 212,     0,     0 },
    { 210,     0,     0 },
    { 209,     0,     0 },
    { 207,     0,     0 },
    { 206,     0,     0 },
    { 204,     0,     0 },
    { 202,     0,     0 },
    { 201,     0,     0 },
    { 199,     0,     0 },
    { 198,     0,     0 },
    { 196,     0,     0 },
    { 194,     0,     0 },
    { 193,     0,     0 },
    { 191,     0,     0 },
    { 190,     0,     0 },
    { 188,     0,     0 },
    { 186,     0,     0 },
    { 185,     0,     0 },
    { 183,     0,     0 },
    { 182,     0,     0 },
    { 180,     0,     0 },
    { 179,     0,     0 },
    { 177,     0,     0 },
    { 175,     0,     0 },
    { 174,     0,     0 },
    { 172,     0,     0 },
    { 171,     0,     0 },
    { 169,     0,     0 },
    { 167,     0,     0 },
    { 166,     0,     0 },
    { 164,     0,     0 },
    { 163,     0,     0 },
    { 161,     0,     0 },
    { 159,     0,     0 },
    { 158,     0,     0 },
    { 156,     0,     0 },
    { 155,     0,     0 },
    { 153,     0,     0 },
    { 151,     0,     0 },
    { 150,     0,     0 },
    { 148,     0,     0 },
    { 147,     0,     0 },
    { 145,     0,     0 },
    { 143,     0,     0 },
    { 142,     0,     0 },
    { 140,     0,     0 },
    { 139,     0,     0 },
    { 137,     0,     0 },
    { 135,     0,     0 },
    { 134,     0,     0 },
    { 132,     0,     0 },
    { 131,     0,     0 },
    { 129,     0,     0 },
    { 128,     0,     0 } };

} // end of namespace rgb8_colors

} // end of namespace doppia
