#ifndef INTEGRAL_CHANNELS_DETECTOR_AMP_HPP
#define INTEGRAL_CHANNELS_DETECTOR_AMP_HPP

#include "objects_detection/DetectorSearchRange.hpp"
#include "objects_detection/SoftCascadeOverIntegralChannelsModel.hpp"
#include "objects_detection/SoftCascadeOverIntegralChannelsFastFractionalStage.hpp"

//#include <cudatemplates/devicememorypitched.hpp>
//#include <cudatemplates/devicememorylinear.hpp>

#include <opencv2/core/version.hpp>
#if CV_MINOR_VERSION <= 3
#include <opencv2/gpu/devmem2d.hpp> // opencv 2.3
#else
#include <opencv2/core/devmem2d.hpp> // opencv 2.4
#endif

#include <boost/cstdint.hpp>

namespace doppia 
{
	namespace objects_detection 
	{
		/// Stump version of integral_channels_detector
		void integral_channels_detector(gpu_integral_channels_t &integral_channels,
			const size_t search_range_index,
			const doppia::DetectorSearchRange &search_range,
			gpu_detection_stump_cascade_per_scale_t &detection_cascade_per_scale,
			const bool use_the_model_cascade,
			cv::gpu::DevMem2Df& detection_scores);
	} // end of namespace objects_detection
} // end of namespace doppia


#endif